import type { $$extensions } from "./interfaces.js";
import { $$safeError } from "./interfaces.js";
export interface GrafastError extends Error {
    originalError: Error;
    [$$extensions]?: Record<string, any>;
}
export declare const $$error: unique symbol;
export declare class _GrafastError extends Error implements GrafastError {
    readonly originalError: Error;
    extensions: Record<string, any>;
    [$$error]: boolean;
    constructor(originalError: Error, planId: number | null);
}
export declare function newGrafastError(error: Error, planId: number | null): _GrafastError;
export declare function isGrafastError(value: any): value is GrafastError;
export declare class SafeError extends Error {
    extensions?: Record<string, any> | undefined;
    [$$safeError]: boolean;
    constructor(message: string, extensions?: Record<string, any> | undefined);
}
export declare function isSafeError(error: Error): error is SafeError;
//# sourceMappingURL=error.d.ts.map