import LRU from "@graphile/lru";
import type { FragmentDefinitionNode, GraphQLSchema, OperationDefinitionNode } from "graphql";
import { OperationPlan } from "./index.js";
import type { BaseGraphQLRootValue, BaseGraphQLVariables } from "./interfaces.js";
type Fragments = {
    [key: string]: FragmentDefinitionNode;
};
interface LinkedList<T> {
    value: T;
    next: LinkedList<T> | null;
}
interface Cache {
    possibleOpPlans: LinkedList<OperationPlan>;
    fragments: Fragments;
}
type CacheByOperation = LRU<OperationDefinitionNode, Cache>;
declare const $$cacheByOperation: unique symbol;
declare module "graphql" {
    interface GraphQLSchema {
        [$$cacheByOperation]?: CacheByOperation;
    }
}
export declare function establishOperationPlan<TVariables extends BaseGraphQLVariables = BaseGraphQLVariables, TContext extends Grafast.Context = Grafast.Context, TRootValue extends BaseGraphQLRootValue = BaseGraphQLRootValue>(schema: GraphQLSchema, operation: OperationDefinitionNode, fragments: Fragments, variableValues: TVariables, context: TContext, rootValue: TRootValue): OperationPlan;
export {};
//# sourceMappingURL=establishOperationPlan.d.ts.map